
#include        <stdlib.h>
#include        <stdio.h>
#include        <string.h>

void shuffle(int *Arr, int size);

struct hashe {
	int	valu;
	int	spare;
	unsigned long long	keyq;
};

struct hashe *findnode(unsigned long long key);

static int suit_ci2x[] = {
	0, 0, 1, 0, 2, 0, 0, 0, 3,
};
static int suit_cx2i[] = {
	1, 2, 4, 8,
};

typedef unsigned int    Card;
#define	NUMSUIT		4
#define	NUMRANK		13
#define	XRANK(x)	((x) & 0xf)
#define	XSUIT(x)	(0xf & ((x) >> 4))

#define	CI2X(x)	((x) == 15+15*16 ? 52 : (x)%16 - 2 + 13*suit_ci2x[(x)/16])
#define	CX2I(x)	((x) == 52 ? 15+15*16 : (x)%13 + 2 + 16*suit_cx2i[(x)/13])

extern char name_rank[], name_suit[];
extern char *valnames[];

char	*name_card(char *out, Card x);
int	s2i(char *inp);
int	pokval(unsigned int c0, unsigned int c1,
		unsigned int c2, unsigned int c3, unsigned int c4);
int	phand(char *msg, unsigned int *han);
void	xpcards(Card *han, int cnt);
