
#include	<stdlib.h>
#include	<stdio.h>

#define NROW    12      /* Don't change, without several other changes too */
#define WID     12      /* Reduce this dimension to reduce memory usage */ 

typedef unsigned short **********Node;

int main(int argc, char **argv)
{
        int             psize[NROW+1], plast, numpile,
                        numrem, i, j, moveno;
        unsigned short  *winbits;
        Node            Posvalue[WID+1], *grow[NROW-2];

#define INDX(i)                                                 \
        (i > plast-1 ? 0 : psize[i+1] - (i >= plast-numpile ? numrem : 0))

#define NFOR(N)                                                 \
        for (psize[N] = 0;                                      \
                psize[N] <= psize[N-1]                          \
                && (N > NROW - 2 || N == NROW - 2 &&            \
                (winbits = (unsigned short *)(*grow[N-1]++      \
                = calloc(1, WID * sizeof (unsigned short))))    \
                || (grow[N] = (Node *)(*grow[N-1]++             \
                = calloc(1, ((unsigned)psize[N]+1)              \
                * sizeof (Node))))); psize[N]++, plast = N)

#define WINNER  (Posvalue                                       \
        [INDX(0)][INDX(1)][INDX(2)][INDX(3)][INDX(4)][INDX(5)]  \
        [INDX(6)][INDX(7)][INDX(8)][INDX(9)][INDX(10)] & 1 << INDX(11))

        grow[0] = Posvalue;
        psize[0] = WID;
        plast = 0;
        /*
         * After the foregoing preliminaries, a brief nested
         * loop suffices to solve every position.
         */
        NFOR(1) NFOR(2) NFOR(3) NFOR(4) NFOR(5) NFOR(6)
        NFOR(7) NFOR(8) NFOR(9) NFOR(10) NFOR(11) NFOR(12) {
                if (plast) {
                        for (numpile = 1; numpile <= plast; numpile++)
                        for (numrem = 1; numrem <= psize[plast]; numrem++)
                                if (WINNER)
                                        goto contin_3;
                        winbits[INDX(10)] |= 1 << INDX(11);
                contin_3: ;
                }
        }
        /* The winning strategies have all been found.
         * Now let's just play at top speed with whoever's
         * at the other end of sockets stdin and stdout.
         */
        while (1) {
                for (j = 1; j < NROW+1; j++)
                        psize[j] = WID;
                plast = NROW;
                for (moveno = 1; plast; moveno++) {
                        for (i = 1; i <= plast; i++)
                                printf("%s%2d%s",
                                        i == 1 ? "  [" : "",
                                        psize[i],
                                        i == plast ? "] : \n" : " ");
                        if (moveno & 1) while (1) {
                                printf("Enter num piles and num beans per pile:\n");
                                scanf("%d %d", &numpile, &numrem);
                                if (numpile >= 1 && numpile <= plast
                                                && numrem >= 1
                                                && numrem <= psize[plast])
                                        break;
                                printf("Illegal move; try again.\n");
                        } else {
                                for (numpile = 1; numpile <= plast; numpile++)
                                for (numrem = 1; numrem <= psize[plast]; numrem++)
                                        if (WINNER)
                                                goto move;
                                numpile = numrem = 1;
                        move:
                                printf("My move: %d piles and %d beans per pile.\n",
                                        numpile, numrem);
                        }
                        for (j = 0; j < NROW; j++)
                                psize[j+1] = INDX(j);
                        for (plast = j = 0; j < NROW; j++)
                                if (psize[j+1])
                                        ++plast;
                }
                printf("%s Win!!!\n", moveno & 1 ? "You" : "I");
                printf("\nLet's play again\n");
        }
}
