
#include	<stdlib.h>
#include	<stdio.h>
#include	<time.h>
#include	"j_random.h"

#define	SP_SIZ	256

/* Define RAN_EFFIC to minimize entropy at expense of speed */
#ifdef	RAN_EFFIC
#define	RAN_EFFIC

#define	SETWALKER	rand_esetwalker
#define	WALKER		rand_ewalker

#else

#define	SETWALKER	rand_setwalker
#define	WALKER		rand_walker
#endif

struct walkerent Walker[SP_SIZ][SP_SIZ][SP_SIZ];

unsigned char	buff[1000030];
#define	OSIZE	20000

int main(int argc, char **argv)
{
	int	siz, i, t1, t2, t3;

	rand_seed(time(0));
	siz = fread(buff, 1, 1000000, stdin);

	for (t1 = 0; t1 < 20; t1++)
		buff[siz + t1] = buff[t1];

	for (t1 = 0; t1 < SP_SIZ; t1++)
	for (t2 = 0; t2 < SP_SIZ; t2++)
	for (t3 = 0; t3 < SP_SIZ; t3++)
		Walker[t1][t2][t3].x1 = t3;

	t2 = buff[0];
	t3 = buff[1];
	for (i = 0; i < siz - 1; i++) {
		t1 = t2;
		t2 = t3;
		t3 = buff[i + 2];
		Walker[t1][t2][t3].prob1 += 1.0;
	}
	for (t1 = 0; t1 < SP_SIZ; t1++)
	for (t2 = 0; t2 < SP_SIZ; t2++)
		SETWALKER(Walker[t1][t2], SP_SIZ);
	/* First two characters of input are reused */
	t2 = buff[0];
	t3 = buff[1];
	for (i = 2; i < OSIZE - 1; i++) {
		t1 = t2;
		t2 = t3;
		t3 = buff[i] = WALKER(Walker[t1][t2], SP_SIZ);
	}
	buff[i] = '\n';
	fwrite(buff, 1, OSIZE, stdout);
	rand_bits(99);
	exit(0);
}
