
/* Convert a UTF-8 file to a UTF-16 file */
#include	<stdio.h>
#include	<stdlib.h>
#include	<unistd.h>
#include	<string.h>

unsigned char	IBuff[30000000];

int main(int argc, char **argv)
{
	int	Iix, Oix;
	int	Isize, Wx, t1, t2, t3;

	Isize = read(0, IBuff, sizeof IBuff);
	Oix = Iix = 0;
	if (IBuff[0] == 0xef && IBuff[1] == 0xbb && IBuff[2] == 0xbf)
		Iix = 3;
	for (; Iix < Isize; ) {
		Wx = t1 = IBuff[Iix++];
		if (Wx > 0xdf) {
			Wx = (Wx & 0x0f) << 12; 
			Wx |= ((t2 = IBuff[Iix++]) & 0x3f) << 6; 
			Wx |= (t3 = IBuff[Iix++]) & 0x3f; 
			if ((t1 >> 4) != 0x0e)
				goto not8; 
			if ((t2 >> 6) != 0x02)
				goto not8; 
			if ((t3 >> 6) != 0x02)
				goto not8; 
		} else if (Wx > 0xbf) {
			Wx = (Wx & 0x01f) << 6; 
			Wx |= (t2 = IBuff[Iix++]) & 0x3f; 
			if ((t1 >> 5) != 0x06)
				goto not8; 
			if ((t2 >> 6) != 0x02) {
			t3 = 0;
			not8:
				fprintf(stderr,
		"Unexpected value in UTF8 file %02x %02x %02x\n",
					t1, t2, t3);
				fprintf(stderr,
		"Iix = %d (0%o) Oix = %d\n", Iix, Iix, Oix);
				exit(1);
			} 
		} else if (Wx > 0x7f) {
			fprintf(stderr,
"Passing through peculiar 10xxxxxx case = %02x\n", Wx);
		}
		printf(Wx < 128 ? "%c" : "&#%d;", Wx);
	}
	exit(0);
}
