
#include	<stdio.h>
#include	<stdlib.h>
#include	"utf_class.h"

static struct ub {
	char	*ub_name;
	int	ub_start;
	int	ub_stop;
} Ubb[309] = {
#include	"uniblock.h"
	"Unassigned", 0, 0,
};

static int	Histog[308 + 1];

void utf_showhist(void)
{
	int	j, k;

	for (j = 0; j < 309; j++)
	if (k = Histog[j]) {
		fprintf(stderr, "%8d instances from Class  *%s*\n",
			k, Ubb[j].ub_name);
	}
}

int utf_class(int val)
{
	int	below = -1, above = 308, probe = 154;

	while (probe > below) {
		if (val < Ubb[probe].ub_start) {
			above = probe;
		} else if (val > Ubb[probe].ub_stop) {
			below = probe;
		} else {
			Histog[probe] += 1;
			return probe;
		}
		probe = (above + below) / 2;
	}
	Histog[308] += 1;
	return 308;
}

#ifdef	TESTING
char	Buff[1000];

int main(int argc, char **argv)
{
	int	j, val;

	while (gets(Buff)) {
		val = strtol(Buff, 0, 0);
		j = utf_class(val);
		printf("%x is in Class %s\n", val, Ubb[j].ub_name);
	}
	exit(0);
}
#endif
