
#include	<stdlib.h>
#include	<stdio.h>
#include	<time.h>
#include	"j_random.h"

struct walkerent Walker[256][256][256];

unsigned char	buff[5000000];
#define	OSIZE	120000

int main(int argc, char **argv)
{
	int	siz, i, t1, t2, t3;
	int	nn;

	rand_seed(time(0));
	siz = fread(buff, 1, 5000000, stdin);

	for (t1 = 0; t1 < 256; t1++)
	for (t2 = 0; t2 < 256; t2++)
	for (t3 = 0; t3 < 256; t3++)
		Walker[t1][t2][t3].x1 = t3;

	t2 = buff[0];
	t3 = buff[1];
	for (i = 0; i < siz - 1; i++) {
		t1 = t2;
		t2 = t3;
		t3 = buff[i + 2];
		Walker[t1][t2][t3].prob1 += 1.0;
	}

#if	0
	for (t3 = 0; t3 < 256; t3++) {
		nn = Walker['p']['h'][t3].prob1 + 0.001;
		if (nn)
			printf("%c --> %d\n", t3, nn);
	}
#endif

	for (t1 = 0; t1 < 256; t1++)
	for (t2 = 0; t2 < 256; t2++)
		rand_setwalker(Walker[t1][t2], 256);
	/* First two characters of input are reused */
	t2 = buff[0];
	t3 = buff[1];
	for (i = 2; i < OSIZE - 1; i++) {
		t1 = t2;
		t2 = t3;
		t3 = buff[i] = rand_walker(Walker[t1][t2], 256);
	}
	buff[i] = '\n';
	fwrite(buff, 1, OSIZE, stdout);
	rand_seed(1);
	exit(0);
}
