
#include	<stdlib.h>
#include	<stdio.h>
#include	<string.h>

#define	BSIZ	8192000
char	buff[BSIZ];
int	histo[256];

int main(int argc, char **argv)
{
	int	i, cnt, thisc, prevchar;
	int	pflag, cflag, total, nflag, oflag;

	total = 0;
	cflag = pflag = 0;
	nflag = oflag = 0;
	prevchar = '\n';
	while (1) {
		if (argc > 1 && ! strcmp(argv[1], "-c"))
			argc--, argv++,
			cflag = 1;
		else if (argc > 1 && ! strcmp(argv[1], "-p"))
			argc--, argv++,
			pflag = 1;
		else if (argc > 1 && ! strcmp(argv[1], "-o"))
			argc--, argv++,
			oflag = 1;
		else if (argc > 1 && ! strcmp(argv[1], "-n"))
			argc--, argv++,
			nflag = 1;
		else
			break;
	}
	while ((cnt = fread(buff, 1, BSIZ, stdin)) > 0) {
		for (i = 0; i < cnt; i++) {
			thisc = buff[i] & 0xff;
			if (nflag == 0 || prevchar == '\n') {
				if (oflag == 0
						|| 'a' <= thisc
						&& thisc <= 'z') {
					++histo[thisc];
					++total;
				}
			}
			prevchar = thisc;
		}
	}
	for (i = 0; i < 256; i++) {
		if (histo[i] == 0)
			continue;
		if (cflag && i >= 0x20 && i < 0x7f)
			printf(" %c ", i);
		else
			printf("%02x ", i);
		if (pflag)
			printf("%f\n", histo[i] / (float)total);
		else
			printf("%9d\n", histo[i]);
	}
	exit(0);
}
