
/*
 * Add more distributions!
 *   Gamma
 *
 * To-Do:
 *   Add a more direct rand_binomial to j_random.c
 */
#include	<stdlib.h>
#include	<stdio.h>

#define	EXIT_GOOD	0
#define	EXIT_PINCON	25	/* arguments inconsistent */
#define	EXIT_USAGE	64	/* command line usage error */

struct onb {
	int	pt, bet, bodds;
	double	mpyr;
} Onbo[6] = {
	4, 0, 0, 2.0,
	5, 0, 0, 1.5,
	6, 0, 0, 1.2,
	8, 0, 0, 1.2,
	9, 0, 0, 1.5,
	10, 0, 0, 2.0,
};

int winnings(struct onb *o, int mode)
{
	if (mode == 'W')
		return o->bet * 2 + o->bodds * (1.01 + 1 / o->mpyr);
	else
		return o->bet * 2 + o->bodds * (1.01 + o->mpyr);
}

int shoboard(int bbank)
{
	int tb = 0;
	struct onb *o;

	printf("ResBank = $%d  ", bbank);
	tb += bbank;
	for (o = Onbo; o < Onbo + 6; o++)
	if (o->bet) {
		printf("[P.%d] $%d+$%d  ",
				o->pt, o->bet, o->bodds);
		tb += o->bet + o->bodds;
	}
	printf("\nTotal money = $%d\n", tb);
	return tb;
} 

char	Buff[9000];
int	Point = 0, Roll;
int	Bet, Bank = 400;
int	Wrongway, Comebets;
int	Lineaction = 0;
int	Oddsaction = 0;

#define	VIGOR	60
/*
 * Betsize will be the larger of $5 or Rounded_down_(Bank/VIGOR)
 * Or double that without Come bets
 */
int main(int argc, char **argv)
{
	struct onb *o, *xo;
	int	tt;

	if (argv[1] && argv[1][1] == 'W')
		argv++, Wrongway = 1;
	if (argv[1] && argv[1][1] == 'C')
		argv++, Comebets = 1;
	if (Comebets) {
		printf(
"You are betting %sPass and %sCome.   Initial bets = $5\n",
			Wrongway ? "Do-Not-" : "",
			Wrongway ? "Do-Not-" : "");
	} else {
		printf(
"You are betting %sPass Only.   Initial bets = $10\n",
			Wrongway ? "Do-Not-" : "",
			Wrongway ? "Do-Not-" : "");
	}
	while (1) {
		if (! shoboard(Bank))
			break;
		if (Comebets || !Point) {
			Bet = 5 * (Bank / (5*VIGOR));
			if (Bet < 5) Bet = 5;
			if (! Comebets) Bet += Bet;
			if (Bet > Bank) Bet = Bank;
			Lineaction += Bet;
		} else {
			Bet = 0;
		}
		if (Point) {
			printf("%d is the point.", Point);
			if (Comebets)
				printf("   You bet $%d on %sCome.\n",
					Bet, Wrongway ? "Do-Not-" : "");
			else
				printf("\n");
		} else {
			printf("Come-out Roll.  You bet $%d on %sPass.\n",
					Bet, Wrongway ? "Do-Not-" : "");
		}
		printf("\n");

		do {
			if (! gets(Buff))
				goto exiting;
			Roll = atoi(Buff);
		} while (Roll < 2 || Roll > 12);

		printf("\nThe Roll is %d.\n", Roll);
		xo = Onbo;
		switch (Roll) {
		case 11:
			printf("   Frontline favorite!\n"); 
			if (Wrongway)
				Bank -= Bet;
			else
				Bank += Bet;
			break;
		case 12:
			if (Wrongway && Bet) {
				printf("   Craps!  Barred for Do-Not.  :-(\n"); 
				break;
			}
			/* FALLTHRU */
		case 2:
		case 3:
			printf("   Craps!\n"); 
			if (Wrongway)
				Bank += Bet;
			else
				Bank -= Bet;
			break;
		case 7:
			if (Point == 0) {
				printf(
"   Natural Seven.  Pay the Front Line.\n");
			} else {
				Point = 0;
				printf(
"   Seven Out.  Line Away.  Last Come and the Do Nots Pay.\n");
			}
			if (Wrongway) {
				Bank -= Bet;
				for (o = Onbo; o < Onbo + 6; o++)
					Bank += winnings(o, 'W');
			} else {
				Bank += Bet;
			}
			for (o = Onbo; o < Onbo + 6; o++)
				o->bet = o->bodds = 0;
			Point = 0;
			break;
		case 10:	xo++; /* FALLTHRU */
		case 9:	xo++; /* FALLTHRU */
		case 8:	xo++; /* FALLTHRU */
		case 6:	xo++; /* FALLTHRU */
		case 5:	xo++; /* FALLTHRU */
		case 4:
			o = xo;
			if (Wrongway) {
			} else {
				Bank += winnings(o, 'R');
			}
			o->bet = o->bodds = 0;
			if (o->bet = Bet) {
				Bank -= Bet;
				tt = Bet * 2;
				if (Wrongway)
					tt *= o->mpyr + 0.001;
				if (tt > Bank)
					tt = Bank;
				Oddsaction += tt;
				o->bodds = tt;
				Bank -= tt;
			}
			if (Point == 0)
				Point = Roll;
			break;
		}
		// Roll = rand_index(6) + rand_index(6) + 2;
	}
	exiting:
	printf("Total of Line bets = $%d.  Total of Odds bets = $%d.\n",
			Lineaction, Oddsaction);
	exit(EXIT_GOOD);
}


