
/* Copyright (c) 2008 James Dow Allen.  All Rights Reserved; see License. */
#define	cuck_MAXPARTS	30

struct cuck_revdesc {
	unsigned long	re_im, re_fm, re_prim;
	size_t	re_mintab;
	unsigned short	re_bentry;
	unsigned short	re_paysz;
	unsigned short	re_igb;
};

struct htab_tab {
	/* The +1 following is for temporary during expansion */
	Bgroup	*cu_ddd[cuck_MAXPARTS + 1];
	size_t	cu_nent[cuck_MAXPARTS + 1];
	size_t	cu_bytes;
	unsigned short	cu_numparts;
	unsigned short	cu_maxparts;
	unsigned short	cu_movecpt;
	/* several fields just for sta print */
	unsigned long	cu_numadd, cu_numdel, cu_numrelo;
	unsigned long	cu_find, cu_probe;
	struct cuck_revdesc cu_revd;
#define	cu_igb		cu_revd.re_igb
#define	cu_im		cu_revd.re_im
#define	cu_fm		cu_revd.re_fm
#define	cu_prim		cu_revd.re_prim
#define	cu_bentry	cu_revd.re_bentry
#define	cu_paysz	cu_revd.re_paysz
#define	cu_mintab	cu_revd.re_mintab
};

struct htab_tab *cuck_create(size_t minsz, size_t minnt, size_t maxnt,
	struct cuck_revdesc *revdp);
struct htab_tab *cuck_mustcreate(size_t minsz, size_t minnt, size_t maxnt,
	struct cuck_revdesc *revdp);
void cuck_free(struct htab_tab *csp);

