
#include	<stdlib.h>
#include	<stdio.h>
#include	<time.h>
#include	"j_random.h"

struct walkerent Walker[128][128];

unsigned char	buff[1000030];
#define	OSIZE	20000

int main(int argc, char **argv)
{
	int	siz, i, t1, t2;

	rand_seed(time(0));
	siz = fread(buff, 1, 1000000, stdin);
	for (t1 = 0; t1 < 20; t1++)
		buff[siz + t1] = buff[t1];

	for (t1 = 0; t1 < 128; t1++)
	for (t2 = 0; t2 < 128; t2++)
		Walker[t1][t2].x1 = t2;

	t2 = buff[0] & 0x7f;
	for (i = 0; i < siz - 1; i++) {
		t1 = t2;
		t2 = buff[i + 1] & 0x7f;
		Walker[t1][t2].prob1 += 1.0;
	}
	for (t1 = 0; t1 < 128; t1++)
		rand_setwalker(Walker[t1], 128);
	/* First character of input is reused */
	t2 = buff[0] & 0x7f;
	for (i = 1; i < OSIZE - 1; i++) {
		t1 = t2;
		t2 = buff[i] = rand_walker(Walker[t1], 128);
	}
	buff[i] = '\n';
	fwrite(buff, 1, OSIZE, stdout);
	exit(0);
}
