
#include	<stdlib.h>
#include	<stdio.h>
#include	<string.h>
#include	"j_random.h"

int	Num_tetrs;
#define	MAX_GLY	80000

struct walkerent Walker[MAX_GLY][256];

#define RAN_EFFIC
#ifdef  RAN_EFFIC

#define SETWALKER       rand_esetwalker
#define WALKER          rand_ewalker

#else

#define SETWALKER       rand_setwalker
#define WALKER          rand_walker
#endif

unsigned char	buff[5000030];
#define	OSIZE	120000

int trig2ix(long trig, int makeit);

int main(int argc, char **argv)
{
	int	siz, i, t1, t2, t3, t4, t5;
	int	nn, ix;

	siz = fread(buff, 1, 5000000, stdin);

	for (t1 = 0; t1 < 20; t1++)
		buff[siz + t1] = buff[t1];

	t2 = buff[0];
	t3 = buff[1];
	t4 = buff[2];
	t5 = buff[3];
	for (i = 0; i < siz; i++) {
		t1 = t2;
		t2 = t3;
		t3 = t4;
		t4 = t5;
		t5 = buff[i + 4];
		ix = trig2ix(t1 << 24 | t2 << 16 | t3 << 8 | t4, 1);
		Walker[ix - 1][t5].prob1 += 1.0;
	}

	fprintf(stderr, "Num_tetrs = %d\n", Num_tetrs);

	for (ix = 0; ix < Num_tetrs; ix++) {
		for (t1 = 0; t1 < 256; t1++)
			Walker[ix][t1].x1 = t1;
		SETWALKER(Walker[ix], 256);
	}

	/* First four characters of input are reused */
	t2 = buff[0];
	t3 = buff[1];
	t4 = buff[2];
	t5 = buff[3];
	for (i = 4; i < OSIZE - 1; i++) {
		t1 = t2;
		t2 = t3;
		t3 = t4;
		t4 = t5;
		ix = trig2ix(t1 << 24 | t2 << 16 | t3 << 8 | t4, 0);
		t5 = buff[i] = WALKER(Walker[ix - 1], 256);
	}
	buff[i] = '\n';
	fwrite(buff, 1, OSIZE, stdout);
	rand_seed(1);
	rand_bits(99);
	exit(0);
}

#define	NUMEL	990001
#define	NUMHCAB	1

struct hashe {
	unsigned long	keyval;
	int	indx;
} Hashe[NUMHCAB][NUMEL];


#define	HT_EMPTY(np)		((np)->indx == 0)
#define HT_MATCH(np, kkk)	((np)->keyval == (kkk) - 1)

/* The above customizes a particular hash table,
 *  Allowing us to use a small generic source function:
 *
 * struct hashe *findnode(unsigned long long key);
 */

#include	"ezhash.c"

int trig2ix(long trig, int makeit)
{
	struct hashe *np;

	np = findnode(trig);
	if (HT_EMPTY(np)) {
		if (!makeit) {
			fprintf(stderr, "No hit on %06x\n", trig);
			exit(1);
		}
		np->keyval = trig;
		np->indx = ++Num_tetrs;
	}
	return np->indx;
}

