
#define		_GNU_SOURCE
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

int time2int(unsigned char *s)
{
	int	hr, mi, se, ms, cnt;

	cnt = sscanf(s, "%d:%d:%d,%d", &hr, &mi, &se, &ms);
	if (cnt != 4) {
		fprintf(stderr, "Count in time2int() %d *%s*\n", cnt, s);
		exit(1);
	}
	ms += ((hr * 60 + mi) * 60 + se) * 1000;
	return ms;
}

unsigned char	Buff[10000];

int main(int argc, char **argv)
{
	unsigned char	*pstop, *bufp;
	int	tstart, tstop;

	setlinebuf(stdout);
	while (bufp = gets(Buff)) {
		pstop = strstr(bufp, "-->");
		tstart = time2int(bufp);
		tstop  = time2int(pstop + 4);
		printf(" %d %s\n", tstop - tstart, Buff);
	}
	exit(0);
}
