
/* Functions in matrix.c */
void	sodump(double *a, int AWID, int AHEI);
void	transpose(double *a, double *b, int AWID, int AHEI);
void	jrotate(double *a, double *b, int size, double mix);
void	submat(double *a, double *b, int AWID, int BWID, int BHEI);
void	normalize(double *a, int AWID, int AHEI);
double	ddotprod(double *a, double *b, int cnt, int binc);
void	multiply(double *a, double *b, double *c, int AWID, int AHEI, int BWID);
void	abat(double *a, double *b, double *c, int AHEI, int BWID);
void	aprint(char *msg, double *a, int AWID, int AHEI);
double	determ(double *in, int size);
int	do_invert(double *in, double *out, int size);
int	matinvert(double *in, double *out, int size);
int	jixcomp(const void *j1, const void *j2);
void	make_eigen(double *keepin, double *out, double *vals, int size);
void	mk_randvect(double *v, int size);
void	iminusa(double *a, double *b, int AWID);
void	mk_projector(double *a, double *b, int AHEI, int AWID);
int	is_projector(double *a, int AHEI);
void	nxt_ortho(double *in, int size, int next);
void	fill_ortho(double *in, int size, int already);

